// DO NOT EDIT.
//
// Generated by the Swift generator plugin for the protocol buffer compiler.
// Source: tensorflow/core/protobuf/saver.proto
//
// For information on using the generated types, please see the documenation:
//   https://github.com/apple/swift-protobuf/

import Foundation
import SwiftProtobuf

// If the compiler emits an error on this type, it is because this file
// was generated by a version of the `protoc` Swift plug-in that is
// incompatible with the version of SwiftProtobuf to which you are linking.
// Please ensure that your are building against the same version of the API
// that was used to generate this file.
fileprivate struct _GeneratedWithProtocGenSwiftVersion: SwiftProtobuf.ProtobufAPIVersionCheck {
  struct _2: SwiftProtobuf.ProtobufAPIVersion_2 {}
  typealias Version = _2
}

/// Protocol buffer representing the configuration of a Saver.
public struct Tensorflow_SaverDef: SwiftProtobuf.Message {
  public static let protoMessageName: String = _protobuf_package + ".SaverDef"

  /// The name of the tensor in which to specify the filename when saving or
  /// restoring a model checkpoint.
  public var filenameTensorName: String = String()

  /// The operation to run when saving a model checkpoint.
  public var saveTensorName: String = String()

  /// The operation to run when restoring a model checkpoint.
  public var restoreOpName: String = String()

  /// Maximum number of checkpoints to keep.  If 0, no checkpoints are deleted.
  public var maxToKeep: Int32 = 0

  /// Shard the save files, one per device that has Variable nodes.
  public var sharded: Bool = false

  /// How often to keep an additional checkpoint. If not specified, only the last
  /// "max_to_keep" checkpoints are kept; if specified, in addition to keeping
  /// the last "max_to_keep" checkpoints, an additional checkpoint will be kept
  /// for every n hours of training.
  public var keepCheckpointEveryNHours: Float = 0

  public var version: Tensorflow_SaverDef.CheckpointFormatVersion = .legacy

  public var unknownFields = SwiftProtobuf.UnknownStorage()

  /// A version number that identifies a different on-disk checkpoint format.
  /// Usually, each subclass of BaseSaverBuilder works with a particular
  /// version/format.  However, it is possible that the same builder may be
  /// upgraded to support a newer checkpoint format in the future.
  public enum CheckpointFormatVersion: SwiftProtobuf.Enum {
    public typealias RawValue = Int

    /// Internal legacy format.
    case legacy // = 0

    /// Deprecated format: tf.Saver() which works with tensorflow::table::Table.
    case v1 // = 1

    /// Current format: more efficient.
    case v2 // = 2
    case UNRECOGNIZED(Int)

    public init() {
      self = .legacy
    }

    public init?(rawValue: Int) {
      switch rawValue {
      case 0: self = .legacy
      case 1: self = .v1
      case 2: self = .v2
      default: self = .UNRECOGNIZED(rawValue)
      }
    }

    public var rawValue: Int {
      switch self {
      case .legacy: return 0
      case .v1: return 1
      case .v2: return 2
      case .UNRECOGNIZED(let i): return i
      }
    }

  }

  public init() {}

  /// Used by the decoding initializers in the SwiftProtobuf library, not generally
  /// used directly. `init(serializedData:)`, `init(jsonUTF8Data:)`, and other decoding
  /// initializers are defined in the SwiftProtobuf library. See the Message and
  /// Message+*Additions` files.
  public mutating func decodeMessage<D: SwiftProtobuf.Decoder>(decoder: inout D) throws {
    while let fieldNumber = try decoder.nextFieldNumber() {
      switch fieldNumber {
      case 1: try decoder.decodeSingularStringField(value: &self.filenameTensorName)
      case 2: try decoder.decodeSingularStringField(value: &self.saveTensorName)
      case 3: try decoder.decodeSingularStringField(value: &self.restoreOpName)
      case 4: try decoder.decodeSingularInt32Field(value: &self.maxToKeep)
      case 5: try decoder.decodeSingularBoolField(value: &self.sharded)
      case 6: try decoder.decodeSingularFloatField(value: &self.keepCheckpointEveryNHours)
      case 7: try decoder.decodeSingularEnumField(value: &self.version)
      default: break
      }
    }
  }

  /// Used by the encoding methods of the SwiftProtobuf library, not generally
  /// used directly. `Message.serializedData()`, `Message.jsonUTF8Data()`, and
  /// other serializer methods are defined in the SwiftProtobuf library. See the
  /// `Message` and `Message+*Additions` files.
  public func traverse<V: SwiftProtobuf.Visitor>(visitor: inout V) throws {
    if !self.filenameTensorName.isEmpty {
      try visitor.visitSingularStringField(value: self.filenameTensorName, fieldNumber: 1)
    }
    if !self.saveTensorName.isEmpty {
      try visitor.visitSingularStringField(value: self.saveTensorName, fieldNumber: 2)
    }
    if !self.restoreOpName.isEmpty {
      try visitor.visitSingularStringField(value: self.restoreOpName, fieldNumber: 3)
    }
    if self.maxToKeep != 0 {
      try visitor.visitSingularInt32Field(value: self.maxToKeep, fieldNumber: 4)
    }
    if self.sharded != false {
      try visitor.visitSingularBoolField(value: self.sharded, fieldNumber: 5)
    }
    if self.keepCheckpointEveryNHours != 0 {
      try visitor.visitSingularFloatField(value: self.keepCheckpointEveryNHours, fieldNumber: 6)
    }
    if self.version != .legacy {
      try visitor.visitSingularEnumField(value: self.version, fieldNumber: 7)
    }
    try unknownFields.traverse(visitor: &visitor)
  }
}

// MARK: - Code below here is support for the SwiftProtobuf runtime.

fileprivate let _protobuf_package = "tensorflow"

extension Tensorflow_SaverDef: SwiftProtobuf._MessageImplementationBase, SwiftProtobuf._ProtoNameProviding {
  public static let _protobuf_nameMap: SwiftProtobuf._NameMap = [
    1: .standard(proto: "filename_tensor_name"),
    2: .standard(proto: "save_tensor_name"),
    3: .standard(proto: "restore_op_name"),
    4: .standard(proto: "max_to_keep"),
    5: .same(proto: "sharded"),
    6: .standard(proto: "keep_checkpoint_every_n_hours"),
    7: .same(proto: "version"),
  ]

  public func _protobuf_generated_isEqualTo(other: Tensorflow_SaverDef) -> Bool {
    if self.filenameTensorName != other.filenameTensorName {return false}
    if self.saveTensorName != other.saveTensorName {return false}
    if self.restoreOpName != other.restoreOpName {return false}
    if self.maxToKeep != other.maxToKeep {return false}
    if self.sharded != other.sharded {return false}
    if self.keepCheckpointEveryNHours != other.keepCheckpointEveryNHours {return false}
    if self.version != other.version {return false}
    if unknownFields != other.unknownFields {return false}
    return true
  }
}

extension Tensorflow_SaverDef.CheckpointFormatVersion: SwiftProtobuf._ProtoNameProviding {
  public static let _protobuf_nameMap: SwiftProtobuf._NameMap = [
    0: .same(proto: "LEGACY"),
    1: .same(proto: "V1"),
    2: .same(proto: "V2"),
  ]
}
